# -*- python -*-
# $RCSfile: brushstyle_.py,v $
# $Revision: 1.6 $
# $Author: langer $
# $Date: 2005/01/14 22:30:16 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


from common import cregisteredclass
from common.IO import parameter
from common.IO import xmlmenudump

cregisteredclass.registerCClass(BrushStylePtr)

circleReg = cregisteredclass.Registration(
    "Circle",
    BrushStylePtr,
    CircleBrush,
    ordering=0,
    params=[parameter.FloatParameter('radius', 0,
                                     tip='Radius of the brush in physical units.')],
    tip="Brush with a circular profile.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/common/reg-circlebrush.xml')
    )

squareReg = cregisteredclass.Registration(
    "Square",
    BrushStylePtr,
    SquareBrush,
    ordering=1,
    params=[parameter.FloatParameter('size', 0,
                                     tip='Half the side of the brush in physical units.')],
    tip="Brush with a square profile.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/common/reg-squarebrush.xml')
    )
