# -*- python -*-
# $RCSfile: ooferror_.py,v $
# $Revision: 1.11 $
# $Author: reida $
# $Date: 2004/08/23 19:37:25 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

#
# Routine to set up the callback that converts C++ exceptions to
# Python exceptions.  This gets automatically run when oofcpp is
# imported, which guarantees that it will be in place before any
# high-level calls from "pure Python" happen.

from common import debug

def pyErrorCallback(str):
    try:
        errorstring = "raise " + str
##        debug.fmsg('errorstring=', errorstring)
##        debug.fmsg()
        exec errorstring
    except TypeError:
        debug.fmsg("Error while raising exception! str=", errorstring,
                   type(errorstring))
        raise

def registerErrorClass(eclass):
    "Allow an error class to be raised from the SWIGged wrapper functions."
    g = globals()
    g[eclass.__name__] = eclass

pyErrorInit(pyErrorCallback)

##################################

import traceback

class ErrPyProgrammingError(ErrProgrammingError):
    def __init__(self, message):
        debug.fmsg('entering ErrPyProgrammingError init')
        stack = traceback.extract_stack()
        # The actual error is two up from us in the stack.
        (file, lineno, func, txt) = stack[-2] 
        ErrProgrammingError.__init__(self, message, file, lineno)
        debug.fmsg('done with ErrPyProgrammingError init')
    def __repr__(self):
        return self.message() 
        

def _ErrProgrammingError___repr__(self):
    return self.message()+"\n("+self.filename()+":"+"%d"%self.lineno() + ")"

ErrProgrammingError.__repr__ = _ErrProgrammingError___repr__


class ErrDataFileError(ErrUserError):
    pass



# At the python level, make all OOF error classes have a __str__ that
# is the same as the __repr__.
def _ErrError___repr__(self):
    return self.__repr__()

ErrErrorPtr.__str__  = _ErrError___repr__

# Highly dangerous weaselry.  We want all exceptions to be subclasses
# of the python "Exception" class, but there is no simple mechanism
# for SWIG'd classes to be subclasses of a pure python class, partcularly
# one we didn't write.  But, we can add "Excpetion" manually to the list
# of base classes.  This sort of manipulation of the class hierarchy
# is very strongly discouraged, except for this one unavoidable instance.
ErrErrorPtr.__bases__ += (Exception,)
