# -*- python -*-
# $RCSfile: initialize.py,v $
# $Revision: 1.109 $
# $Author: langer $
# $Date: 2005/01/31 21:37:39 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


# All components of engine that need initialization *before* they're
# used should be imported here.  Using OOFexec makes the names
# available in the __main__ environment in text mode.

from common import debug
from common import parallel_enable
from common import utils

import SWIG.engine.ooferror2

import engine.materialplugin
utils.OOFexec('from engine.problem import *')
import engine.IO.propertymenu
import engine.IO.materialmenu

import engine.builtinprops
import engine.skeleton
import engine.skeletoncontext
import engine.skeletonselectionmodes
import SWIG.engine.masterelement
import SWIG.engine.material
import SWIG.engine.eulerangle
import engine.boundary
import engine.IO.outputDefs
#import engine.IO.strain
import engine.IO.displaymethods
import engine.IO.contourdisplay
import engine.fieldinit

import engine.IO.skeletonmenu
import engine.IO.pinnodesmenu
import engine.IO.boundarymenu
import engine.IO.boundarycondition
import engine.mesh
import SWIG.engine.femesh
import engine.IO.meshmenu
utils.OOFexec('from SWIG.engine import solver')

# skeleton and mesh modification stuff
import engine.refine
import engine.anneal
import engine.relaxation
import engine.smooth
import engine.snapnode
import engine.splitquads
import engine.rationalize
import engine.rationalshort
import engine.rationalwide
import engine.rationalsharp
import engine.edgeswap
import engine.mergetriangles
import engine.refinementtarget
import engine.vigilante
import engine.meshmod
import engine.skeletonmodifier

import engine.pixelselect
import SWIG.engine.pixelselectioncouriere
import engine.skeletonselectionmod
import engine.IO.skeletonselectiontoolbox
import engine.IO.skeletoninfo
import engine.IO.meshinfo
import engine.IO.movenode
import engine.IO.pinnodes
import engine.IO.meshcstoolbox

import engine.IO.skeletoninfodisplay
import engine.IO.meshinfodisplay
import engine.IO.movenodedisplay
import engine.IO.pinnodesdisplay
import engine.IO.meshcsdisplay

import engine.IO.elementselectdisplay
import engine.IO.nodeselectdisplay
import engine.IO.segmentselectdisplay
import engine.IO.skeletonbdydisplay
import engine.IO.skeletonselectmenu
import engine.IO.skeletongroupmenu
import engine.IO.microstructuredisplay
import engine.IO.solvermenu

import engine.IO.analyzemenu
import engine.IO.meshbdymenu

import SWIG.engine.cstrain

if parallel_enable.query() == 1:
    import engine.IO.materialmenuIPC
    import engine.IO.skeletonIPC
    import engine.deputyParallel
