# -*- makefile -*-
# $RCSfile: subdir.mk,v $
# $Revision: 1.2 $
# $Author: reida $
# $Date: 2004/08/05 01:22:47 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modifed
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 
#
# This is some GNU make code that is used to recursively construct
# a Makefile through includes. Boy, am I feeling clever!

# We abuse the variable system so that $(dircache$(dir)) points to 
# the parent directory name every time we 'descend'. That way, even
# though there are no local variables, we can always pop back up.
parent := $(dir)

# Construct our current directory name
dir := $(dir)$(dirname)/
dircache$(dir) := $(parent)

# Tack on the C,h files and subdirectories in this directory
cfiles := $(cfiles:%=$(dir)%)
CFILES += $(cfiles)
HFILES += $(hfiles:%=$(dir)%)
SWIGFILES += $(swigfiles:%=$(dir)%)
SWIGPYFILES += $(swigpyfiles:%=$(dir)%)
PYFILES += $(pyfiles:%=$(dir)%)
subdirs := $(subdirs:%=$(dir)%)
SUBDIRS += $(dir)

# Make sure that .o files that would live under this subdir
# have a subdir to live under in the build directory. This
# adds a rule that makes the .o file is dependent on its dir.
#$(cfiles:.C=.o): $(BUILD)/$(dir).placeholder
#$(swigfiles:.swg=.o): $(BUILD)/$(dir).placeholder
# Technically, the .C and .py files only go in the build tree if
# GPATH is unset, but the dirs will need to be made anyhow, so should
# make them earlier if need be.
#$(swigfiles:.swg=cmodule.C): $(BUILD)/$(dir).placeholder
#$(swigfiles:.swg=.py): $(BUILD)/$(dir).placeholder

# Recursive call through subdirs
ifeq ($(subdirs),)
  :
else
  # Blank out possible variable names
  cfiles    :=
  hfiles    :=
  swigpyfiles   :=
  pyfiles :=
  swigfiles :=
  sd := $(subdirs)
  subdirs   :=
  include $(sd:%=$(srcdir)/%/DIR.mk)
endif

# Blank out possible variable names
cfiles    :=
hfiles    :=
swigpyfiles   :=
pyfiles   :=
swigfiles :=
subdirs   :=

# Pop up the stack
dir := $(dircache$(dir))

